// C++ definition

#include "QCDNUM/QCDNUM.h"
//#include "QCDNUM/CHARACTER.h"
#include "QCDNUM/QCDNUMfw.h"

#include <sstream>
#include <cstring>
#include <string>
#include <iostream>
using namespace std;

#define STR_EXPAND(top) #top
#define STR(tok) STR_EXPAND(tok)

namespace MBUTIL {

  /**************************************************************/
  /*  MBUTIL hash routines from hash.f                          */
  /**************************************************************/

  //--------------------------------------------------------------
    int imb_ihash(int iseed, int *imsg, int n)
    {
      return fimb_ihash(&iseed, imsg, &n);
    }
  //--------------------------------------------------------------
    int imb_jhash(int iseed, double *dmsg, int n)
    {
      return fimb_jhash(&iseed, dmsg, &n);
    }
  //--------------------------------------------------------------
    int imb_dhash(int iseed, double *dmsg, int n)
    {
      return fimb_dhash(&iseed, dmsg, &n);
    }

  /**************************************************************/
  /*  MBUTIL character routines from mchar.f                    */
  /**************************************************************/

//----------------------------------------------------------------
  void smb_hcode(int ihash, string &hcode)
  {
    int ls = 15;
    char *mychar = new char[ls];
    fsmb_hcodecpp(&ihash,mychar,&ls);
    hcode = "";
    for(int i = 0; i < ls; i++) {
      hcode = hcode + mychar[i];
    }
  }

  /**************************************************************/
  /*  MBUTIL workspace routines from wspace.f                   */
  /**************************************************************/

  //--------------------------------------------------------------
    int imb_wsinit(double *w, int nw, int nt)
    {
      int ia = fimb_wsinit(w, &nw, &nt);
      return iaFtoC(ia);
    }
  //--------------------------------------------------------------
    void smb_setwsn(double *w, int nw)
    {
     fsmb_setwsn(w, &nw);
    }
  //--------------------------------------------------------------
    int imb_newset(double *w)
    {
     int ia = fimb_newset(w);
     return iaFtoC(ia);
    }
  //--------------------------------------------------------------
    int imb_wtable(double* w, int* imi, int* ima, int n)
    {
     int ia = fimb_wtable(w, imi, ima, &n);
     return iaFtoC(ia);
    }
  //--------------------------------------------------------------
    int imb_wclone(double *obj, double *w2)
    {
     int ja1    = int(*(obj+1));
     double *w1 = obj-ja1;
     int ia1    = iaCtoF(ja1);
     int ia     = fimb_wclone(w1, &ia1, w2);
     return iaFtoC(ia);
    }
  //--------------------------------------------------------------
    void smb_tbcopy(double *tab1, double *tab2, int itag)
    {
     int ja1    = int(*(tab1+1));
     int ja2    = int(*(tab2+1));
     double *w1 = tab1-ja1;
     double *w2 = tab2-ja2;
     int ia1    = iaCtoF(ja1);
     int ia2    = iaCtoF(ja2);
     fsmb_tbcopy(w1, &ia1, w2, &ia2, &itag);
    }
  //--------------------------------------------------------------
    void smb_tsdump(string fname, int key, double *tset, int &ierr)
    {
     int ls = fname.size();
     char *cfname = new char[ls];
     strcpy(cfname,fname.c_str());
     int ja     = int(*(tset+1));
     double *w  = tset-ja;
     int ia     = iaCtoF(ja);
     fsmb_tsdumpcpp(cfname, &ls, &key, w, &ia, &ierr);
    }
  //--------------------------------------------------------------
    int imb_tsread(string fname, int key, double *w, int &ierr)
    {
     int ls = fname.size();
     char *cfname = new char[ls];
     strcpy(cfname,fname.c_str());
     int ia = fimb_tsreadcpp(cfname, &ls, &key, w, &ierr);
     return iaFtoC(ia);
    }
  //--------------------------------------------------------------
    int imb_marker(string obj)
    {
     int ls = obj.size();
     char *cobj = new char[ls];
     strcpy(cobj,obj.c_str());
     return fimb_markercpp(cobj,&ls);
    }
  //--------------------------------------------------------------
    int imb_hdsize()
    {
     return fimb_hdsize();
    }
  //--------------------------------------------------------------
    int imb_tbsize(int *imi, int *ima, int ndim)
    {
     return fimb_tbsize(imi, ima, &ndim);
    }
  //--------------------------------------------------------------
    int imb_tpoint(double *table, int *index, int n)
    {
     int ja    = int(*(table+1));
     double *w = table-ja;
     int ia    = iaCtoF(ja);
     int iadr  = fimb_tpoint(w, &ia, index, &n);
     return iaFtoC(iadr);
    }
  //--------------------------------------------------------------
    int imb_IsaWorkspace(double *w)
    {
     return fimb_isaworkspace(w);
    }
  //--------------------------------------------------------------
    int imb_SizeOfW(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     return fimb_sizeofw(w);
    }
  //--------------------------------------------------------------
    int imb_WordsUsed(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     return fimb_wordsused(w);
    }
  //--------------------------------------------------------------
    int imb_Nheader(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     return fimb_nheader(w);
    }
  //--------------------------------------------------------------
    int imb_Ntags(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     return fimb_ntags(w);
    }
  //--------------------------------------------------------------
    int imb_HeadSkip(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     return fimb_headskip(w);
    }
  //--------------------------------------------------------------
    int imb_IaDrain(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     int ja    = fimb_iadrain(w);
     return iaFtoC(ja);
    }
  //--------------------------------------------------------------
    int imb_IaNull(double *obj)
    {
     int ia    = int(*(obj+1));
     double *w = obj-ia;
     int ja    = fimb_ianull(w);
     return iaFtoC(ja);
    }
  //--------------------------------------------------------------
    int imb_ObjectType(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_objecttype(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_ObjectSize(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_objectsize(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_Nobjects(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_nobjects(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_ObjectNumber(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_objectnumber(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_FingerPrint(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_fingerprint(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_IaFirstTag(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     int ift   = fimb_iafirsttag(w, &ia);
     return iaFtoC(ift);
    }
  //--------------------------------------------------------------
    int imb_TableDim(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_tabledim(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_IaKARRAY(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     int iak   = fimb_iakarray(w, &ia);
     return iaFtoC(iak);
    }
  //--------------------------------------------------------------
    int imb_IaIMIN(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     int iak   = fimb_iaimin(w, &ia);
     return iaFtoC(iak);
    }
  //--------------------------------------------------------------
    int imb_IaIMAX(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     int iak   = fimb_iaimax(w, &ia);
     return iaFtoC(iak);
    }
  //--------------------------------------------------------------
    int imb_BeginTbody(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     int iak   = fimb_begintbody(w, &ia);
     return iaFtoC(iak);
    }
  //--------------------------------------------------------------
    int imb_EndTbody(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     int iak   = fimb_endtbody(w, &ia);
     return iaFtoC(iak);
    }
  //--------------------------------------------------------------
    int imb_dchdir(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_dchdir(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_dfskip(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_dfskip(w, &ia);
    }
  //--------------------------------------------------------------
    int imb_dbskip(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     return fimb_dbskip(w, &ia);
    }
  //--------------------------------------------------------------
    void smb_wstree(double *w)
    {
     int iroot    = 0;
     fsmbwstree(w,&iroot);
    }
  //--------------------------------------------------------------
    void smb_wshead(double *obj)
    {
     int ja    = int(*(obj+1));
     double *w = obj-ja;
     int ia    = iaCtoF(ja);
     fsmb_wshead(w,&ia);
    }

}
