// C++ definition

#include "QCDNUM/QCDNUM.h"
//#include "QCDNUM/CHARACTER.h"
#include "QCDNUM/QCDNUMfw.h"

#include <sstream>
#include <cstring>
#include <string>
#include <iostream>
using namespace std;

#define STR_EXPAND(top) #top
#define STR(tok) STR_EXPAND(tok)

namespace QCDNUM {

  /**************************************************************/
  /*  TOOLBOX init routines from tbx00ini.f                     */
  /**************************************************************/

  //--------------------------------------------------------------
    void tbx_wsinit(double *w, int nw)
    {
      ftbx_wsinit(w, &nw);
    }

  /**************************************************************/
  /*  TOOLBOX pointer routines from tbxpointer.f                */
  /**************************************************************/


  /**************************************************************/
  /*  TOOLBOX workspace routines from tbxwspace.f               */
  /**************************************************************/


  /**************************************************************/
  /*  QCDNUM evolution routines from usrevol.f                  */
  /**************************************************************/

//----------------------------------------------------------------
  double rfromf(double fscale2)
  {
    return frfromf(&fscale2);
  }
//----------------------------------------------------------------
  double ffromr(double rscale2)
  {
    return fffromr(&rscale2);
  }
//----------------------------------------------------------------
  double asfunc(double r2, int &nf, int &ierr)
  {
    return fasfunc(&r2,&nf,&ierr);
  }
//----------------------------------------------------------------
  double altabn(int iset, int iq, int n, int &ierr)
  {
    return faltabn(&iset,&iq,&n,&ierr);
  }
//----------------------------------------------------------------
  void evolfg(int iset, double (*func) (int*, double*), double *def, int iq0, double &epsi)
  {
    fevolfg(&iset,func,def,&iq0,&epsi);
  }
//----------------------------------------------------------------
  void evsgns(int iset, double (*func)(int*, double*), int *isns, int n, int iq0, double &epsi)
  {
    fevsgns(&iset,func,isns,&n,&iq0,&epsi);
  }
//----------------------------------------------------------------
  void pdfcpy(int iset1, int iset2)
  {
    fpdfcpy(&iset1,&iset2);
  }
//----------------------------------------------------------------
  void extpdf(double (*func)(int*, double*, double*, bool*), int iset, int n, double offset, double &epsi)
  {
    fextpdf(func,&iset,&n,&offset,&epsi);
  }
//----------------------------------------------------------------
  void usrpdf(double (*func)(int*, double*, double*, bool*), int iset, int n, double offset, double &epsi)
  {
    fusrpdf(func,&iset,&n,&offset,&epsi);
  }
//----------------------------------------------------------------
  int nptabs(int iset)
  {
    return fnptabs(&iset);
  }
//----------------------------------------------------------------
  int ievtyp(int iset)
  {
    return fievtyp(&iset);
  }

  /**************************************************************/
  /*  QCDNUM grid routines from usrgrd.f                        */
  /**************************************************************/

//----------------------------------------------------------------
  void gxmake(double *xmin, int *iwt, int n, int nxin, int &nxout, int iord)
  {
    fgxmake(xmin,iwt,&n,&nxin,&nxout,&iord);
  }
//----------------------------------------------------------------
  int ixfrmx(double x)
  {
    return fixfrmx(&x);
  }
//----------------------------------------------------------------
  int xxatix(double x, int ix)
  {
    return fxxatix(&x,&ix);
  }
//----------------------------------------------------------------
  double xfrmix(int ix)
  {
    return fxfrmix(&ix);
  }
//----------------------------------------------------------------
  void gxcopy(double *array, int n, int &nx)
  {
    fgxcopy(array,&n,&nx);
  }
//----------------------------------------------------------------
  void gqmake(double *qarr, double *wgt, int n, int nqin, int &nqout)
  {
    fgqmake(qarr,wgt,&n,&nqin,&nqout);
  }
//----------------------------------------------------------------
  int iqfrmq(double q2)
  {
    return fiqfrmq(&q2);
  }
//----------------------------------------------------------------
  int qqatiq(double q2, int iq)
  {
    return fqqatiq(&q2,&iq);
  }
//----------------------------------------------------------------
  double qfrmiq(int iq)
  {
    return fqfrmiq(&iq);
  }
//----------------------------------------------------------------
  void gqcopy(double *array, int n, int &nq)
  {
    fgqcopy(array,&n,&nq);
  }
//----------------------------------------------------------------
  void grpars(int &nx, double &xmi, double &xma, int &nq, double &qmi, double &qma, int &iord)
  {
    fgrpars(&nx,&xmi,&xma,&nq,&qmi,&qma,&iord);
  }
//---------------------------------------------------------------------
  void setlim( int ixmin, int iqmin, int iqmax, double dummy)
  {
    fsetlim(&ixmin,&iqmin,&iqmax,&dummy);
  }
//---------------------------------------------------------------------
  void getlim( int iset, double &xmin, double &qmin, double &qmax, double &dummy)
  {
    fgetlim(&iset,&xmin,&qmin,&qmax,&dummy);
  }

  /**************************************************************/
  /*  QCDNUM init routines from usrini.f                        */
  /**************************************************************/

//----------------------------------------------------------------
  void qcinit(int lun, string fname)
  {
    int ls = fname.size();
    char *cfname = new char[ls];
    strcpy(cfname,fname.c_str());
    fqcinitcpp(&lun,cfname,&ls);
  }
//----------------------------------------------------------------
  void setlun(int lun, string fname)
  {
    int ls = fname.size();
    char *cfname = new char[ls];
    strcpy(cfname,fname.c_str());
    fsetluncpp(&lun,cfname,&ls);
  }
//----------------------------------------------------------------
  int nxtlun(int lmin)
  {
    return fnxtlun(&lmin);
  }
//----------------------------------------------------------------
  void setval(string opt, double val)
  {
    int ls = opt.size();
    char *copt = new char[ls];
    strcpy(copt,opt.c_str());
    fsetvalcpp(copt,&ls,&val);
  }
//----------------------------------------------------------------
  void getval(string opt, double &val)
  {
    int ls = opt.size();
    char *copt = new char[ls];
    strcpy(copt,opt.c_str());
    fgetvalcpp(copt,&ls,&val);
  }
//----------------------------------------------------------------
  void setint(string opt, int ival)
  {
    int ls = opt.size();
    char *copt = new char[ls];
    strcpy(copt,opt.c_str());
    fsetintcpp(copt,&ls,&ival);
  }
//----------------------------------------------------------------
  void getint(string opt, int &ival)
  {
    int ls = opt.size();
    char *copt = new char[ls];
    strcpy(copt,opt.c_str());
    fgetintcpp(copt,&ls,&ival);
  }
//----------------------------------------------------------------
  void qstore(string opt, int ival, double &val)
  {
    int ls = opt.size();
    char *copt = new char[ls];
    strcpy(copt,opt.c_str());
    fqstorecpp(copt,&ls,&ival,&val);
  }

  /**************************************************************/
  /*  QCDNUM parameter routines from usrparams.f                */
  /**************************************************************/

//----------------------------------------------------------------
  void setord(int iord)
  {
    fsetord(&iord);
  }
//----------------------------------------------------------------
  void getord(int &iord)
  {
    fgetord(&iord);
  }
//----------------------------------------------------------------
  void setalf(double as0, double r20)
  {
    fsetalf(&as0,&r20);
  }
//----------------------------------------------------------------
  void getalf(double &as0, double &r20)
  {
    fgetalf(&as0,&r20);
  }
//----------------------------------------------------------------
  void setcbt(int nfix, int iqc, int iqb, int iqt)
  {
    fsetcbt(&nfix,&iqc,&iqb,&iqt);
  }
//----------------------------------------------------------------
  void mixfns(int nfix, double r2c, double r2b, double r2t)
  {
    fmixfns(&nfix,&r2c,&r2b,&r2t);
  }
//----------------------------------------------------------------
  void getcbt(int &nfix, double &q2c, double &q2b, double &q2t)
  {
    fgetcbt(&nfix,&q2c,&q2b,&q2t);
  }
//----------------------------------------------------------------
  void setabr(double ar, double br)
  {
    fsetabr(&ar,&br);
  }
//----------------------------------------------------------------
  void getabr(double &ar, double &br)
  {
    fgetabr(&ar,&br);
  }
//----------------------------------------------------------------
  int nfrmiq(int iset, int iq, int &ithresh)
  {
    return fnfrmiq(&iset,&iq,&ithresh);
  }
//----------------------------------------------------------------
  int nflavs(int iq, int &ithresh)
  {
    return fnflavs(&iq,&ithresh);
  }
//----------------------------------------------------------------
  void cpypar(double *array, int n, int iset)
  {
    fcpypar(array,&n,&iset);
  }
//----------------------------------------------------------------
  void usepar(int iset)
  {
    fusepar(&iset);
  }
//----------------------------------------------------------------
  int keypar(int iset)
  {
    return fkeypar(&iset);
  }
//----------------------------------------------------------------
  int keygrp(int iset, int igrp)
  {
    return fkeygrp(&iset,&igrp);
  }
//----------------------------------------------------------------
  void pushcp()
  {
    fpushcp();
  }
//----------------------------------------------------------------
  void pullcp()
  {
    fpullcp();
  }

  /**************************************************************/
  /*  QCDNUM pdf output routines from usrpdf.f                  */
  /**************************************************************/

//----------------------------------------------------------------
  void allfxq(int iset, double x, double qmu2, double *pdfs, int n, int ichk)
  {
    fallfxq(&iset,&x,&qmu2,pdfs,&n,&ichk);
  }
//----------------------------------------------------------------
  void allfij(int iset, int ix, int iq, double *pdfs, int n, int ichk)
  {
    fallfij(&iset,&ix,&iq,pdfs,&n,&ichk);
  }
//----------------------------------------------------------------
  double bvalxq(int iset, int id, double x, double qmu2, int ichk)
  {
    return fbvalxq(&iset,&id,&x,&qmu2,&ichk);
  }
//----------------------------------------------------------------
  double bvalij(int iset, int id, int ix, int iq, int ichk)
  {
    return fbvalij(&iset,&id,&ix,&iq,&ichk);
  }
//----------------------------------------------------------------
  double fvalxq(int iset, int id, double x, double qmu2, int ichk)
  {
    return ffvalxq(&iset,&id,&x,&qmu2,&ichk);
  }
//----------------------------------------------------------------
  double fvalij(int iset, int id, int ix, int iq, int ichk)
  {
    return ffvalij(&iset,&id,&ix,&iq,&ichk);
  }
//----------------------------------------------------------------
  double sumfxq(int iset, double *c, int isel, double x, double qmu2, int ichk)
  {
    return fsumfxq(&iset,c,&isel,&x,&qmu2,&ichk);
  }
//----------------------------------------------------------------
  double sumfij(int iset, double *c, int isel, int ix, int iq, int ichk)
  {
    return fsumfij(&iset,c,&isel,&ix,&iq,&ichk);
  }
//----------------------------------------------------------------
  double fsplne(int iset, int id, double x, int iq)
  {
    return ffsplne(&iset,&id,&x,&iq);
  }
//----------------------------------------------------------------
  double splchk(int iset, int id, int iq)
  {
    return fsplchk(&iset,&id,&iq);
  }
//----------------------------------------------------------------
  void fflist(int iset, double *c, int m, double *x, double *q, double *f, int n, int ichk)
  {
    ffflist(&iset,c,&m,x,q,f,&n,&ichk);
  }
//----------------------------------------------------------------
  void ftable(int iset, double *c, int m, double *x, int nx, double *q, int nq, double *table, int ichk)
  {
    fftable(&iset,c,&m,x,&nx,q,&nq,table,&ichk);
  }
//----------------------------------------------------------------
  void ffplot(string fname, double(* fun)(int*, double*, bool*), int m, double zmi, double zma, int n, string txt)
  {
    int ls1 = fname.size();
    char *cfname = new char[ls1];
    strcpy(cfname,fname.c_str());
    int ls2 = txt.size();
    char *ctxt = new char[ls2];
    strcpy(ctxt,txt.c_str());
    fffplotcpp(cfname,&ls1,fun,&m,&zmi,&zma,&n,ctxt,&ls2);
  }

  /**************************************************************/
  /*  QCDNUM weight routines from usrwgt.f                      */
  /**************************************************************/

//----------------------------------------------------------------
  void fillwt(int itype, int &idmin, int &idmax, int &nwds)
  {
    ffillwt(&itype,&idmin,&idmax,&nwds);
  }
//----------------------------------------------------------------
  void dmpwgt(int itype, int lun, string fname)
  {
    int ls = fname.size();
    char *cfname = new char[ls];
    strcpy(cfname,fname.c_str());
    fdmpwgtcpp(&itype,&lun,cfname,&ls);
  }
//----------------------------------------------------------------
  void readwt(int lun, string fname, int &idmin, int &idmax, int &nwds, int &ierr)
  {
    int ls = fname.size();
    char *cfname = new char[ls];
    strcpy(cfname,fname.c_str());
    freadwtcpp(&lun,cfname,&ls,&idmin,&idmax,&nwds,&ierr);
  }
//----------------------------------------------------------------
  void wtfile(int itype, string fname)
  {
    int ls = fname.size();
    char *cfname = new char[ls];
    strcpy(cfname,fname.c_str());
    fwtfilecpp(&itype,cfname,&ls);
  }
//----------------------------------------------------------------
  void nwused(int &nwtot, int &nwuse, int &ndummy)
  {
    fnwused(&nwtot,&nwuse,&ndummy);
  }

}
